//+------------------------------------------------------------------+
//|                                              getInternetFile.mq4 |
//|                                                            Erics |
//|                                                  erics.fx@tut.by |
//+------------------------------------------------------------------+
#property copyright "Erics"
#property link      "erics.fx@tut.by"
#property show_inputs

#define mlqAgent "MQL4 script"
#define PRE_CONFIG_INTERNET_ACCESS 0
#define INTERNET_OPEN_TYPE_DIRECT 1
#define INTERNET_OPEN_TYPE_PROXY 3
#define INTERNET_FLAG_EXISTING_CONNECT 0x20000000
#define INTERNET_FLAG_RELOAD 0x80000000

#import "wininet.dll"
  int   InternetOpenA(string sAgent, int lAccessType, string sProxyName, string sProxyBypass, int lFlags);
  int   InternetCloseHandle(int hInet);
  int   InternetOpenUrlA(int hInternetSession, string lpszUrl, string lpszHeaders, int dwHeadersLength, int dwFlags, int dwContext);
  bool  InternetReadFile(int hFile, int& intBuffer[], int lNumBytesToRead, int& lNumberOfBytesRead[]);
  bool  InternetQueryDataAvailable(int hFile, int& lpdwNumberOfBytesAvailable[], int dwFlags, int dwContext);
  int   InternetSetFilePointer(int hFile, int lDistanceToMove, int pReserved, int dwMoveMethod, int dwContext);
#import

extern string sURL = "http://championship.mql4.com/i/";
extern string sFileName = "2008_03.gif";

//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
void start()
{
  int b = getInternetFile(sURL, sFileName);
  if(b<0) Print("getInternetFile error ", b);
}
//+------------------------------------------------------------------+

int getInternetFile(string sURL, string sFileName, string saveFileAs = "")
{
  int    hSession, hURL, hFile, dloadP, t;
  int    intBuffer[256], bytes[1], FileSz[1], LocalFileSz;
  bool   bRead, haveSize;
  string rs = "";
  
  //   
  if(saveFileAs=="") saveFileAs = sFileName;
  if(saveFileAs=="") saveFileAs = "_tmp.html";
  hFile = FileOpen(saveFileAs,  FILE_BIN | FILE_READ | FILE_WRITE);
  if(hFile==-1) return(-1);
  LocalFileSz = FileSize(hFile);
  //  -
  hSession = InternetOpenA(mlqAgent, PRE_CONFIG_INTERNET_ACCESS, "", "", 0);
  //  URL
  if(hSession<=0) return(-2);
  hURL = InternetOpenUrlA(hSession, sURL+sFileName, "", 0, 0, 0);
  if(hURL<=0) return(-3);
  //   
  haveSize = InternetQueryDataAvailable(hURL, FileSz, 0, 0);
  if(LocalFileSz>0) {
    // 
    FileSeek(hFile, 0, SEEK_END); //     
    dloadP = InternetSetFilePointer(hURL, LocalFileSz, 0, 0, 0); //    
    if(dloadP!=LocalFileSz) FileSeek(hFile, dloadP, SEEK_SET);   // ,  
  }
Print(": ",dloadP);
  
  t=GetTickCount();
  bytes[0]=1024;
  while(bytes[0]==1024)
  {
    //    
    bRead = InternetReadFile(hURL, intBuffer, 1024, bytes);
    if(!bRead) return(-4);
    FileWriteArray(hFile, intBuffer, 0, bytes[0]/4);
    dloadP += bytes[0];
Print("...... ",dloadP-bytes[0]%4);
    if(IsStopped()) break;
  }
  int r = bytes[0]%4; //   r 
  if(r>0) {
    int n = intBuffer[bytes[0]/4]; //  
    for(int i=0; i<r; i++) {
      rs = rs + CharToStr(n & 0xFF);
      n >>= 8;
    }
    FileWriteString(hFile, rs, r);
  }
  FileClose(hFile);
Print(": ",dloadP);
  t=GetTickCount() - t;
Print("  ", 1.0*t/1000, " . (", 1.0*t/60000, " .)");
  //  
  InternetCloseHandle(hURL);
  InternetCloseHandle(hSession);
  return(dloadP); //   
}

